Testing
=======

Please write unit tests for new things.  Tests can be run with `make check`,
which just runs `./testenv bats cases` in the `test/` directory. You will need
the `bats` tool (the `bash-bats` Parabola package) in order to run the tests.
`./testenv` can be given `--no-network` and/or `--no-sudo` to dissable tests
which require those things. You can also pass them to make as `TESTENVFLAGS`.
If you don't dissable either, I *strongly* recommend setting TMPDIR to somewhere
on a btrfs partition before running the tests; otherwise the chroot tests will
take forever.  I mean, they already take long on btrfs, but without it... _dang_.

I also recommend having the `haveged` daemon running. Some of the tests generate
GPG keys. This "should" take on the order of 1 second, but can take several
minutes if you don't have `haveged` running.
